/* Agent.cpp */
#include "Agent.h"

Agent::Agent(repast::AgentId id, Vect dis, Vect vel, Vect acc,  Vect updis_, Vect upvel_, Vect upacc_): id_(id), dis_(dis), vel_(vel), acc_(acc), updis(updis_), upvel(upvel_), upacc(upacc_)
{
	mass=1;
	force_.x=0;
	force_.y=0;
	force_.z=0;
	 
}

Agent::~Agent(){ }


double Agent::getmass(){
	return mass;
	}
	
Vect Agent::getdis(){
	return dis_;
	}
Vect Agent::getvel(){
	return vel_;
	}	

Vect Agent::getacc(){
	return acc_;
	}	

Vect Agent::getupdis(){
	return updis;
	}
	
Vect Agent::getupvel(){
	return upvel;
	}
	
Vect Agent::getupacc(){
	return upacc;
	}	

void Agent::initforce(){
	force_.x=0;
	force_.y=0;
	force_.z=0;
	}

void Agent::addforce(Vect force){
	force_.x+=force.x;
	force_.y+=force.y;
	force_.z+=force.z;
	}

void Agent::computupacc(){
	upacc.x=force_.x/mass;
	upacc.y=force_.y/mass;
	upacc.z=force_.z/mass;
	
	}

		
		
void Agent::set(int currentRank, Vect dis, Vect vel, Vect acc, Vect updis_, Vect upvel_, Vect upacc_){
    id_.currentRank(currentRank);
    dis_ = dis;
    vel_ = vel;
    acc_ = acc;
    updis = updis_;
    upvel = upvel_;
    upacc = upacc_;
}

void Agent::setdis(Vect dis){
    dis_.x = dis.x;
    dis_.y = dis.y;
    dis_.z = dis.z;
}

void Agent::setvel(Vect vel){
    vel_.x = vel.x;
    vel_.y = vel.y;
    vel_.z = vel.z;
}

void Agent::setacc(Vect acc){
    acc_.x = acc.x;
    acc_.y = acc.y;
    acc_.z = acc.z;
}

void Agent::setupdis(Vect dis){
    updis.x = dis.x;
    updis.y = dis.y;
    updis.z = dis.z;
    
}

void Agent::setupvel(Vect vel){
    upvel.x = vel.x;
    upvel.y = vel.y;
    upvel.z = vel.z;
    
}

void Agent::setupacc(Vect acc){
    upacc.x = acc.x;
    upacc.y = acc.y;
    upacc.z = acc.z;
    
}

void Agent::update(){
	dis_ = updis;
	vel_ = upvel;
	acc_ = upacc;
    
}
//~ bool Agent::cooperate(){
	//~ return repast::Random::instance()->nextDouble() < c/total;
//~ }

//~ void Agent::play(repast::SharedContext<Agent>* context){
    //~ std::set<Agent*> agentsToPlay;
	//~ 
    //~ agentsToPlay.insert(this); // Prohibit playing against self
	//~ 
    //~ context->selectAgents(3, agentsToPlay, true);
	//~ 
    //~ double cPayoff     = 0;
    //~ double totalPayoff = 0;
    //~ std::set<Agent*>::iterator agentToPlay = agentsToPlay.begin();
    //~ while(agentToPlay != agentsToPlay.end()){
        //~ bool iCooperated = cooperate();                          // Do I cooperate?
        //~ double payoff = (iCooperated ?
						 //~ ((*agentToPlay)->cooperate() ?  7 : 1) :     // If I cooperated, did my opponent?
						 //~ ((*agentToPlay)->cooperate() ? 10 : 3));     // If I didn't cooperate, did my opponent?
        //~ if(iCooperated) cPayoff += payoff;
        //~ totalPayoff             += payoff;
		//~ 
        //~ agentToPlay++;
    //~ }
    //~ c      += cPayoff;
    //~ total  += totalPayoff;
	//~ 
//~ }


void Agent::setR(){
  R.clear();
  R.push_back(updis.x-dis_.x);
  R.push_back(updis.y-dis_.y);
  R.push_back(updis.z-dis_.z);
}

std::pair<bool, repast::Point<double> > Agent::move(repast::Grid<Agent, double>* grid){
  std::pair<bool, repast::Point<double> > retVal = grid->moveByDisplacement(this, R);
  return retVal;
}


//~ /* Serializable Agent Package Data */
//~ 
AgentPackage::AgentPackage(){ }

AgentPackage::AgentPackage(int _id, int _rank, int _type, int _currentRank, Vect _dis, Vect _vel, Vect _acc, Vect _updis, Vect _upvel, Vect _upacc):
id(_id), rank(_rank), type(_type), currentRank(_currentRank), dis(_dis), vel(_vel), acc(_acc), updis(_updis), upvel(_upvel), upacc(_upacc){ }
